/*		

*/

// -------------------------------------------------------------------------------------------------------------

#include "ext.h"							
#include "ext_obex.h"
#include "jpatcher_api.h"
	
// -------------------------------------------------------------------------------------------------------------

typedef struct _flop {
	t_object		ob ;
	t_object		*mypatcher ;	
	t_object		*mypatcherview ;
	void			*m_out ;
	} t_flop ;
	
// -------------------------------------------------------------------------------------------------------------	
	
void	*flop_new	(t_symbol *s, long argc, t_atom *argv) ;
void	flop_free	(t_flop *x) ;

void	flop_attach	(t_flop *x) ;
void	flop_notify (t_flop *x, t_symbol *s, t_symbol *msg, void *sender, void *data) ;

// -------------------------------------------------------------------------------------------------------------

static t_class *flop_class ;

int main (void)
	{	
		t_class *c = NULL ;
		
		c = class_new ("flop", (method)flop_new, (method)flop_free, (long)sizeof(t_flop), 0L, A_GIMME, 0) ;
		
		class_addmethod (c, (method)flop_notify, "notify", A_CANT, 0) ; 

		class_register (CLASS_BOX, c) ;
		
		flop_class = c ;
		
		return 0 ;
	}

void *flop_new (t_symbol *s, long argc, t_atom *argv)
	{
		t_flop *x = NULL ;
		
		if (x = (t_flop *)object_alloc (flop_class)) 
			{	
				x->mypatcher = NULL ;
				x->mypatcherview = NULL ;
				
				defer_low (x, (method)flop_attach, NULL, 0, NULL) ;
			}
				
		return x ;
	}

void flop_free (t_flop *x)
	{ 
		if (x->mypatcherview) 
			{
				object_detach_byptr (x, x->mypatcherview) ;
			}
	}

// -------------------------------------------------------------------------------------------------------------

void flop_attach (t_flop *x)
	{
		object_obex_lookup (x, gensym ("#P"), &x->mypatcher) ;

		x->mypatcherview = jpatcher_get_firstview (x->mypatcher) ;
		
		object_attach_byptr_register (x, x->mypatcherview, CLASS_NOBOX) ;
	}

void flop_notify (t_flop *x, t_symbol *s, t_symbol *msg, void *sender, void *data)
	{
		if (msg == gensym ("attr_modified") && sender == x->mypatcherview) 
			{ 			
				t_symbol *attr_name = NULL ;
				
				attr_name = (t_symbol *)object_method (data, gensym ("getname")) ;
				
				if (attr_name) 
					{
						post ("%s", attr_name->s_name) ;
					}
			}
	}

// -------------------------------------------------------------------------------------------------------------
// -----------------------------------------------------------------------------------------------------------:x